#include "theBiasPlanet/coreUtilities/collectionsHandling/ListsFactory.hpp"
#include <string>

namespace theBiasPlanet {
	namespace coreUtilities {
		namespace collectionsHandling {
			template <typename T, typename ... U> list <T> * ListsFactory::createList (list <T> * const a_resultList, T const & a_currentElement, U const & ... a_remainingElements) {
				a_resultList->push_back (a_currentElement);
				return createList (a_resultList, a_remainingElements ...);
			}
			
			template <typename T> list <T> * ListsFactory::createList (list <T> * const a_resultList) {
				return a_resultList;
			}
			
			template <typename T, typename ... U> list <T> ListsFactory::createList (T const & a_currentElement, U const & ... a_remainingElements) {
				list <T> l_list;
				createList (&l_list, a_currentElement, a_remainingElements ...);
				return l_list;
			}
			
			
			template <typename T, typename ... U> list <T> * ListsFactory::createListExpandingItems (list <T> * const a_resultList, T const & a_currentElement, U const & ... a_remainingElements) {
				a_resultList->push_back (a_currentElement);
				return createListExpandingItems (a_resultList, a_remainingElements ...);
			}
			
			template <typename T, typename ... U> list <T> * ListsFactory::createListExpandingItems (list <T> * const a_resultList, list <T> const & a_currentElement, U const & ... a_remainingElements) {
				for (T l_subElement : a_currentElement) {
					a_resultList->push_back (l_subElement);
				}
				return createListExpandingItems (a_resultList, a_remainingElements ...);
			}
			
			template <typename T> list <T> * ListsFactory::createListExpandingItems (list <T> * const a_resultList) {
				return a_resultList;
			}
			
			template <typename T, typename ... U> list <T> ListsFactory::createListExpandingItems (T const & a_currentElement, U const & ... a_remainingElements) {
				list <T> l_list;
				createListExpandingItems (&l_list, a_currentElement, a_remainingElements ...);
				return l_list;
			}
			
			template <typename T, typename ... U> list <T> ListsFactory::createListExpandingItems (list <T> const & a_currentElement, U const & ... a_remainingElements) {
				list <T> l_list;
				createListExpandingItems (&l_list, a_currentElement, a_remainingElements ...);
				return l_list;
			}
		}
	}
}

