#include "theBiasPlanet/coreUtilities/stringsHandling/StringTokenizer.hpp"

#include <iostream>

using namespace ::std;

namespace theBiasPlanet {
	namespace coreUtilities {
		namespace stringsHandling {
			StringTokenizer::StringTokenizer (string const & a_originalString, string const a_delimiter) : i_originalStringStream (stringstream (a_originalString)), i_delimiter (a_delimiter) {
			}
			
			optional <string> StringTokenizer::nextToken () {
				string l_token ("");
				string l_tokenFragment;
				size_t const l_delimiterLength = i_delimiter.size ();
				char const l_delimiterLastCharacter = i_delimiter.back ();
				string const l_delimiterHeader = i_delimiter.substr (0, l_delimiterLength - 1);
				while (true) {
					if (getline (i_originalStringStream, l_tokenFragment, l_delimiterLastCharacter)) {
						l_token += l_tokenFragment;
						if (i_originalStringStream.eof ()) {
							return l_token;
						}
						else {
							if (l_delimiterLength > 1) {
								if (l_token.substr (l_token.size () - l_delimiterLength) == l_delimiterHeader) {
									return l_token;
								}
								else {
								}
							}
							else {
								return l_token;
							}
						}
					}
					else {
						return nullopt;
					}
				}
			}
		}
	}
}

