#include "theBiasPlanet/unoUtilities/collectionsHandling/UnoSequenceHandler.hpp"
#include <iomanip>
#include <iostream>
#include "theBiasPlanet/unoUtilities/unoDataHandling/UnoDatumConverter.hpp"

using namespace ::com::sun::star::uno;
using namespace ::rtl;
using namespace ::theBiasPlanet::unoUtilities::unoDataHandling;

namespace theBiasPlanet {
	namespace unoUtilities {
		namespace collectionsHandling {
			template <typename T, typename U> Sequence <U> * UnoSequenceHandler::fillSequence (Sequence <U> * a_sequence, list <T> const & a_list) {
				a_sequence->realloc (a_list.size ());
				int l_elementIndex = 0;
				for (T const &l_element: a_list) {
					(*a_sequence) [l_elementIndex] = UnoDatumConverter::convertToUnoDatum (l_element);
					l_elementIndex ++;
				}
				return a_sequence;
			}
			
			template <typename T, typename U> Sequence <U> * UnoSequenceHandler::fillSequence (Sequence <U> * a_sequence, set <T> const & a_set) {
				a_sequence->realloc (a_set.size ());
				int l_elementIndex = 0;
				for (T const &l_element: a_set) {
					(*a_sequence) [l_elementIndex] = UnoDatumConverter::convertToUnoDatum (l_element);
					l_elementIndex ++;
				}
				return a_sequence;
			}
			
			template <typename T, typename U> list <U> * UnoSequenceHandler::fillList (list <U> * a_list, Sequence <T> const & a_sequence) {
				int l_numberOfSequenceElements = a_sequence.getLength ();
				for (int l_sequenceElementIndex = 0; l_sequenceElementIndex < l_numberOfSequenceElements; l_sequenceElementIndex ++) {
					a_list->push_back (UnoDatumConverter::convertToNonUnoDatum (a_sequence [l_sequenceElementIndex]));
				}
				return a_list;
			}
			
			template <typename T> string UnoSequenceHandler::toString (Sequence <T> const & a_sequence) {
				ostringstream l_stringStream;
			   	l_stringStream << string ("[");
				int l_numberOfSequenceElements = a_sequence.getLength ();
				for (int l_sequenceElementIndex = 0; l_sequenceElementIndex < l_numberOfSequenceElements; l_sequenceElementIndex ++) {
					if (l_sequenceElementIndex == 0) {
					}	
					else {
						l_stringStream << string (", ");
					}
					l_stringStream << UnoDatumConverter::convertToNonUnoDatum (a_sequence [l_sequenceElementIndex]);
				}
				l_stringStream << string ("]");
				return l_stringStream.str ();
			}
		}
	}
}

