#include "theBiasPlanet/unoUtilities/servicesHandling/UnoServiceHandler.hpp"
#include <com/sun/star/uno/XInterface.hpp>
#include "theBiasPlanet/unoUtilities/collectionsHandling/UnoSequenceHandler.hpp"
#include "theBiasPlanet/unoUtilities/stringsHandling/UnoExtendedStringHandler.hpp"

using namespace ::com::sun::star::uno;
using namespace ::theBiasPlanet::unoUtilities::collectionsHandling;
using namespace ::theBiasPlanet::unoUtilities::connectionsHandling;
using namespace ::theBiasPlanet::unoUtilities::stringsHandling;

namespace theBiasPlanet {
	namespace unoUtilities {
		namespace servicesHandling {
			template <typename T> Reference <T> UnoServiceHandler::getServiceInstance (Reference <UnoObjectsContext> a_unoObjectsContext, string const & a_serviceName, optional <list <Any>> const & a_arguments) {
				Reference <XInterface> l_serviceInstance;
				Reference <T> l_targetProxy;
				if (!a_arguments.has_value ()) {
					//l_serviceInstance = a_unoObjectsContext->getServiceManager ()->createInstanceWithContext (UnoExtendedStringHandler::getOustring (a_serviceName), Reference <XComponentContext> (a_unoObjectsContext));
					l_serviceInstance = a_unoObjectsContext->getServiceManager ()->createInstanceWithContext (UnoExtendedStringHandler::getOustring (a_serviceName), a_unoObjectsContext);
				}
				else {
					Sequence <Any> l_argumentsSequence;
					//l_serviceInstance = a_unoObjectsContext->getServiceManager ()->createInstanceWithArgumentsAndContext (UnoExtendedStringHandler::getOustring (a_serviceName), *(UnoSequenceHandler::fillSequence <Any> (&l_argumentsSequence, a_arguments.value ())), Reference <XComponentContext> (a_unoObjectsContext));
					l_serviceInstance = a_unoObjectsContext->getServiceManager ()->createInstanceWithArgumentsAndContext (UnoExtendedStringHandler::getOustring (a_serviceName), *(UnoSequenceHandler::fillSequence <Any> (&l_argumentsSequence, a_arguments.value ())), a_unoObjectsContext);
				}
				if (l_serviceInstance.get () != nullptr) {
					l_targetProxy =  Reference <T> (l_serviceInstance, UNO_QUERY);
				}
				return l_targetProxy;
			}
		}
	}
}

