#include "theBiasPlanet/unoUtilities/unoDataHandling/UnoDatumConverter.hpp"

#include "theBiasPlanet/unoUtilities/stringsHandling/UnoExtendedStringHandler.hpp"

using namespace ::theBiasPlanet::unoUtilities::stringsHandling;

namespace theBiasPlanet {
	namespace unoUtilities {
		namespace unoDataHandling  {
			template <typename T, typename U> list <U> UnoDatumConverter::convertToNonUnoDatum (Sequence <T> const & a_unoDatum) {
				list <U> l_list;
				UnoSequenceHandler::fillList (&l_list, a_unoDatum);
				return l_list;
			}
			
			template <typename T> T UnoDatumConverter::convertToNonUnoDatum (T const & a_unoDatum) {
				return a_unoDatum;
			}
			
			template <typename T, typename U> Sequence <U> UnoDatumConverter::convertToUnoDatum (list <T> const & a_nonUnoDatum) {
				Sequence <U> l_sequence;
				UnoSequenceHandler::fillSequence (&l_sequence, a_nonUnoDatum);
				return l_sequence;
			}
			
			template <typename T> T UnoDatumConverter::convertToUnoDatum (T const & a_nonUnoDatum) {
				return a_nonUnoDatum;
			}
			
			template <typename T> Any UnoDatumConverter::convertToUnoAnyDatum  (T const & a_nonUnoDatum) {
				return Any (convertToUnoDatum (a_nonUnoDatum));
			}
			
			template <typename T> Any UnoDatumConverter::convertToUnoAnyDatum  (optional <T> const & a_nonUnoDatum) {
				if (a_nonUnoDatum.has_value ()) {
					return Any (convertToUnoDatum (*a_nonUnoDatum));
				}
				else {
					return Any ();
				}
			}
		}
	}
}

