namespace theBiasPlanet {
	namespace unoUtilities {
		namespace documentsHandling {
			namespace textDocumentsHandling {
				using System;
				using unoidl.com.sun.star.lang;
				using unoidl.com.sun.star.text;
				using theBiasPlanet.unoUtilities.connectionsHandling;
				using theBiasPlanet.unoUtilities.constantsGroups;
				
				public class UnoTextDocument : UnoDocument {
					private XTextDocument i_textDocumentInXTextDocument;
					private XTextViewCursorSupplier i_controllerInXTextViewCursorSupplier;
					public UnoTextDocument (UnoObjectsContext a_unoObjectsContext, XComponent a_textDocumentInXComponent) : base (a_unoObjectsContext, a_textDocumentInXComponent) {
						i_textDocumentInXTextDocument = (XTextDocument) a_textDocumentInXComponent;
						if (i_textDocumentInXTextDocument == null) {
							throw new Exception (UnoMessagesConstantsGroup.c_isNotTextDocument);
						}
						i_controllerInXTextViewCursorSupplier = (XTextViewCursorSupplier) i_controllerInXController;
					}
					
					public static UnoTextDocument createTextDocument (UnoObjectsContext a_unoObjectsContext, bool a_hiddenly) {
						return new UnoTextDocument (a_unoObjectsContext, UnoDocument.createUnoDocumentOrOpenUnoDocumentFile (a_unoObjectsContext, UnoSpecialFileUrlsConstantsGroup.c_writerNewDocument, null, a_hiddenly));
					}
					
					public static UnoTextDocument openTextDocumentFile (UnoObjectsContext a_unoObjectsContext, String a_fileUrl, String a_password, bool a_hiddenly) {
						return new UnoTextDocument (a_unoObjectsContext, UnoDocument.createUnoDocumentOrOpenUnoDocumentFile (a_unoObjectsContext, a_fileUrl, a_password, a_hiddenly));
					}
					
					public static UnoTextDocument getCurrentTextDocument (UnoObjectsContext a_unoObjectsContext) {
						return new UnoTextDocument (a_unoObjectsContext, getCurrentUnoDocument (a_unoObjectsContext));
					}
					
					public XTextViewCursor getViewCursor () {
						return i_controllerInXTextViewCursorSupplier.getViewCursor ();
					}
				}
			}
		}
	}
}

